.686			
.XMM
.model 	flat, stdcall
option 	casemap:none

include	c:\masm32\include\windows.inc
include	c:\masm32\include\kernel32.inc
include	c:\masm32\include\masm32.inc
include	c:\masm32\macros\macros.asm
include	c:\masm32\macros\timers.asm
includelib	c:\masm32\lib\kernel32.lib
includelib	c:\masm32\lib\masm32.lib

Main				proto

dword2hex1 proto :dword, :dword
dword2hex proto :dword, :dword
d2hex       proto :dword, :dword 
DwHds proto :dword, :dword

MakeHexChar macro reg:req, pos:req
   cmp reg, "9"
   jbe @F
   add reg, 7
@@:
   mov byte ptr [eax + pos], reg
endm

.data

	LOOP_COUNT	EQU	100000000		; 1M iterations per timing result

    align 4
	MyValue						dd	  1C2B3A4Bh	 
	retva								dd 0
	Szdw2hex1					DB  "Dword2Hex1: ",0,0
	Szdw2hexBiterider		DB  "Dword2Hex : ",0,0
	Szdw2hexJeff				DB  "DwH->Jeff : ",0,0
	Szdw2hexdsouza			DB  "D-dsouzaf : ",0,0

	align 4
	xTable db "0123456789ABCDEF"  ;translation table

	align 4
	 b2hlut  db "000102030405060708090A0B0C0D0E0F"
             db "101112131415161718191A1B1C1D1E1F"
             db "202122232425262728292A2B2C2D2E2F"
             db "303132333435363738393A3B3C3D3E3F"
             db "404142434445464748494A4B4C4D4E4F"
             db "505152535455565758595A5B5C5D5E5F"
             db "606162636465666768696A6B6C6D6E6F"
             db "707172737475767778797A7B7C7D7E7F"
             db "808182838485868788898A8B8C8D8E8F"
             db "909192939495969798999A9B9C9D9E9F"
             db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
             db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
             db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
             db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
             db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
             db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"


.data?
	align 4
	MyBuffer	db		32 dup(?)

.code
Start:
	Invoke	Main
	Invoke	ExitProcess, 0
Main	Proc
	mov	eax, input(" Please terminate any high-priority tasks and press ENTER to begin.")
    	print	chr$(13,10,13,10," Dword2Hex Tests:",13,10,13,10)
; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
    comment * Dword2Hex1 *
	print	addr Szdw2hex1
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke	dword2hex1, addr MyBuffer, MyValue 
	counter_end
	print	ustr$(eax)
	print	chr$("  clocks; Result: ")
	print	addr MyBuffer
	print	chr$(" ",13,10)
	invoke	Sleep, 250
 ; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
	comment * Dword2Hex by Biterider *
	print	addr Szdw2hexBiterider
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke	dword2hex, addr MyBuffer, MyValue 
	counter_end
	print	ustr$(eax)
	print	chr$("  clocks; Result: ")
	print	 addr MyBuffer
	print	chr$(" ",13,10)
	invoke	Sleep, 250
 ; ------------------------------------------------------------------------------------------------------------------------------------------------------------  

 	comment * Dword2Hex by Jeff *
	print	addr Szdw2hexJeff
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke	 d2hex, addr MyBuffer, MyValue
	counter_end
	print	ustr$(eax)
	print	chr$(" clocks; Result: ")
	print	addr MyBuffer
	print	chr$(" ",13,10)
	invoke	Sleep, 250
 ; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
  	comment * Dword2Hex by Jeff *
	print	addr 	Szdw2hexdsouza
	counter_begin	LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke	 DwHds, addr MyBuffer, addr  MyValue
	counter_end
	print	ustr$(eax)
	print	chr$("  clocks; Result: ")
	print	addr MyBuffer
	print	chr$(" ",13,10)
	invoke	Sleep, 250

	mov	eax, input(13,10," Press ENTER to exit...")
	ret
Main	EndP

; ------------------------------------------------------------------------------------------------------------------------------------------------------------  
comment 		* Dword2Hex1 *
align 		16
;##########################################################################
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
dword2hex1	proc pBuffe:DWORD, MyVal1:DWORD
   mov edx, [esp + 8]
   mov ecx, edx
   mov eax, [esp + 4]
   shr edx, 4
   and ecx, 0F0F0F0Fh
   and edx, 0F0F0F0Fh
   add ecx, "0000"
   mov byte ptr [eax + 8], 0
   add edx, "0000"
   
   MakeHexChar cl, 7
   MakeHexChar dl, 6
   MakeHexChar ch, 5
   shr ecx, 16
   MakeHexChar dh, 4
   MakeHexChar cl, 3
   shr edx, 16
   MakeHexChar dl, 2
   MakeHexChar ch, 1
   MakeHexChar dh, 0
   ret 8
dword2hex1 endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

comment * Dword2Hex by Biterider *

OPTION PROLOGUE:none
OPTION EPILOGUE:none
align 4
dword2hex proc lpBuf:dword, dVal:dword
   mov edx, [esp + 8]
   mov ecx, edx
   shr edx, 4

   and edx, 0F0F0F0Fh
   and ecx, 0F0F0F0Fh
   add edx, "0000"
   add ecx, "0000"

   mov eax, [esp + 4]

   MakeHexChar cl, 7
   MakeHexChar dl, 6
   MakeHexChar ch, 5
   MakeHexChar dh, 4
   shr ecx, 16
   shr edx, 16
   MakeHexChar cl, 3
   MakeHexChar dl, 2
   MakeHexChar ch, 1
   MakeHexChar dh, 0
   mov byte ptr [eax + 8], 0
   ret 8
dword2hex endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

comment * Dword2Hex by Jeff *
OPTION PROLOGUE:none
OPTION EPILOGUE:none
align 4
d2hex proc  pBufi:dword, Val1:dword
push ebx
push edi
    MOV edi, [esp+4+2*4]       ;destination buffer for ascii representation
    MOV ebx,OFFSET xTable       ;translation table
    MOV eax,[esp+8+2*4]              ;number to represent
    MOV ecx, 8                   ;convert a 32bit number
    TOP:
        ROL eax,4               ;rotate the leftmost nibble to the low part (since it's read left-right)
        PUSH eax                ;save the current rotation
        AND eax,0Fh             ;zero out all but the first nibble (to be used as an index)
        XLATB                   ;use the index to get the ascii representation
        STOSB                   ;move the translated byte to the buffer
        POP eax                 ;restore the current rotation
    LOOP TOP 
	pop edi
	pop ebx
    ret 8
 d2hex endp
 OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
   
comment * Dword2Hex by dsouza123 *
OPTION PROLOGUE:none
OPTION EPILOGUE:none
Align 16
DwHds			proc lBuf2:dword, lValue:dword
		mov		edx, [esp+4]			; edx->lp of  MyBuffer
        mov		ecx,  [esp+8]			; edx->offset of  MyValue
		movzx	eax, byte ptr [ecx]
	    movzx	eax, word ptr [b2hlut+eax*2]
   		mov		byte ptr [edx+8], 0	; end of string 
		mov		[edx+6], ax
		movzx	eax, byte ptr [ecx+1]
        movzx	eax, word ptr [b2hlut+eax*2]
        mov		[edx+4], ax
		movzx	eax, byte ptr [ecx+2]
		movzx	ecx, byte ptr [ecx+3]
        mov		ax, word ptr [b2hlut+eax*2]
        mov		cx, word ptr [b2hlut+ecx*2]
        mov		[edx+2], ax
        mov		[edx], cx
	  	ret		8
DwHds			endp 
 OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

End	Start




